#ifndef __BuddhaBounding_H__
#define __BuddhaBounding_H__

#include <d3d9.h>
#include "BuddhaVector3.h"

namespace BuddhaXNA
{
	/**
	 * @brief oEfBOXtBA\
	 * @todo  BoundingSphere \̂͊Jr̂̂łB
	 */
	struct BoundingSphere
	{
	public:
		/// oEfBOXtBA̒SW
		Vector3 Center;

		/// a
		FLOAT Radius;

		/// RXgN^B傫[̃oEfBOXtBA쐬B
		BoundingSphere()
			: Center(Vector3::Zero), Radius(0.0f)
		{
		}

		/**
		 * @brief RXgN^Bw肳ꂽp[^̃oEfBOXtBA쐬B
		 * @par center SW
		 * @par radius a
		 */
		BoundingSphere(Vector3 center, FLOAT radius)
			: Center(center), Radius(radius)
		{
		}

		/// rZq == ̃I[o[[h
		inline bool operator == (const BoundingSphere& b)
		{
			return (Center == b.Center && Radius == b.Radius);
		}

		/// rZq != ̃I[o[[h
		inline bool operator != (const BoundingSphere& b)
		{
			return (Center != b.Center || Radius != b.Radius);
		}

		/// Q̃XtBAĂ邩ǂl擾B
		bool Intersects(const BoundingSphere &sphere)
		{
			Vector3 distance = this->Center - sphere.Center;
			return distance.Distance() < this->Radius + sphere.Radius;
		}
	};
}

#endif