#ifndef __BuddhaHardwareEffect_H__
#define __BuddhaHardwareEffect_H__

#include "BuddhaEffect.h"
#include "BuddhaEffectTechnique.h"
#include "BuddhaEffectPass.h"
#include "BuddhaGraphicsDevice.h"
#include "BuddhaMatrix.h"
#include "BuddhaHardwareEffectLight.h"
#include "BuddhaColor.h"

#include <d3d9.h>

#define	BUDDHA_HARDWARE_NUM_LIGHTS	4

namespace BuddhaXNA
{
	/**
	 * @brief n[hEFAGtFNgC^[tFCX
	 * @remarks
	 *     n[hEFAGtFNg XNA  BasicEffect ɗގ@\񋟂
	 *     GtFNgC^[tFCXłB
	 * \par
	 *     vO}uVF[_̃C^[tFCX邱Ƃ\łB
	 */
	class IHardwareEffect
	{
		/// vWFNVs̐ݒ
		virtual void SetProjectionMatrix(const Matrix &mat) = NULL;

		/// r[s̐ݒ
		virtual void SetViewMatrix(const Matrix &mat) = NULL;

		/// [hs̐ݒ
		virtual void SetWorldMatrix(const Matrix &mat) = NULL;
	};

	class Model;
	class HardwareEffectPass;

	/**
	 * @brief n[hEFAGtFNg
	 * @remarks
	 *     ̃GtFNǵi_ŁjA_~[̃GtFNgNXłÃNX
	 *     gpꍇACũrgC`惍WbNɂăn[hEFA
	 *     @\pCvCp`悪s܂B
	 * \par
	 *     BasicEffect Ɠl̈ӖA܂AvO}uVF[_
	 *     n[hEFAœ삳邱ƂlĒ`Ă܂B
	 * \par
	 *      HardwareEffect  SetParameter() eNjbN̐؂ւȂǂׂ͂
	 *     ܂B܂AŒ@\g߂ɓʂȃeNjbNƓʂȃpX݂̂
	 *     ^܂B
	 */
	class HardwareEffect : public Effect, IHardwareEffect
	{
		friend Model;
		friend HardwareEffectPass;

	protected:
		HardwareEffect(GraphicsDevice* device);

		GraphicsDevice *m_pDevice;

		Matrix mWorldMatrix;
		Matrix mViewMatrix;
		Matrix mProjectionMatrix;

		Color mAmbientColor;

		bool mLightingEnabled;

		HardwareEffectLight mLightList[BUDDHA_HARDWARE_NUM_LIGHTS];

	public:
		~HardwareEffect();

		void Begin();
		void End(){}

		void SetCurrentTechnique(LPCSTR name){}
		void SetCurrentTechnique(String &name){}
		void _setCurrentTechnique(_BuddhaHandle handle){}
		void SetParameter(LPCSTR handle, const Matrix &mat){}
		void SetParameter(LPCSTR handle, const Matrix*, unsigned int count){}
		void SetParameter(LPCSTR handle, const D3DXVECTOR4 &vec){}
		void SetParameter(LPCSTR handle, const Vector3 &vec){}
		void SetParameter(LPCSTR handle, const Vector4 &vec){}
		void SetParameter(LPCSTR handle, const Texture2D* tex){}
		void SetParameter(LPCSTR handle, const float value){}

		_BuddhaHandle _getParameterByHandle(LPCSTR name){ return NULL; }

		_BuddhaHandle _getTechniqueByName(LPCSTR name){ return NULL; }

		void SetParameter(LPCSTR handle, const Color &color){}
		void _commit(void){}

		bool _isGpuEffect(void) const
		{
			return false;
		}

		void SetProjectionMatrix(const Matrix &projMat)
		{
			mProjectionMatrix = projMat;
		}

		void SetViewMatrix(const Matrix &viewMat)
		{
			mViewMatrix = viewMat;
		}

		void SetWorldMatrix(const Matrix &worldMat)
		{
			mWorldMatrix = worldMat;
		}

		/// CgvZLɂ邩
		void SetLightingEnabled(bool bLighting)
		{
			mLightingEnabled = bLighting;
		}

		/// w肳ꂽCfbNX̃Cg擾
		IHardwareEffectLight* GetLight(int idx)
		{
			if (idx < BUDDHA_HARDWARE_NUM_LIGHTS)
				return &mLightList[idx];

			return NULL;
		}

		/// ArGgF̐ݒ
		void SetAmbientColor(const Color &color)
		{
			mAmbientColor = color;
		}
	};

	/**
	 * @brief HardwareEffect p̃eNjbNNX
	 *
	 * ̃eNjbN HardwareEffect ɂĊmۂA HardwareEffectPass ݂̂
	 * z̃pXƂĎ^܂B
	 */
	class HardwareEffectTechnique : EffectTechnique
	{
		friend HardwareEffect;

	protected:
		HardwareEffectTechnique(HardwareEffect* effect);

	public:
		~HardwareEffectTechnique()
		{
		}

		int GetNumPasses(void)
		{
			return 1;
		}

		EffectPass* GetPass(unsigned int idx)
		{
			return mEffectPassList[0];
		}
	};
}

#endif