#ifndef __BuddhaIteratorWrappers_H__
#define __BuddhaIteratorWrappers_H__

#include "BuddhaXNAException.h"

namespace BuddhaXNA
{
	/**
	 * @brief vector, list ReĩCe[^bv
	 *
	 * ̃NX́ANX̓ŎgpĂReiJ邱ƂȂ
	 * Ce[VƂł郉bp[B
	 * gp͎O`FbN end ̏`FbNsvB
	 */
	template <class T>
	class VectorIterator
	{
	private:
		typename T::iterator mCurrent;
		typename T::iterator mEnd;

		// p[^̂ȂRXgN^͎gpłȂ
		VectorIterator() {}

	public:
		typedef typename T::value_type ValueType;

		/**
		 * @brief RXgN^
		 * @param start Ce[^̊Jnn_
		 * @param end   Ce[^̏In_
		 */
		VectorIterator(typename T::iterator start, typename T::iterator end)
			: mCurrent(start),
			  mEnd(end)
		{
		}

		/**
		 * @brief RXgN^
		 * @param c list, vector nRei
		 */
		explicit VectorIterator(T &c)
			: mCurrent(c.begin()),
			  mEnd(c.end())
		{
		}

		/**
		 * @brief Ce[^I[ɒBĂ邩ǂl擾
		 * @return RNVɂ܂vfꍇ͐^Ԃ
		 */
		bool HasMoreElements(void) const
		{
			return mCurrent != mEnd;
		}

		/**
		 * @brief vfoAvfփCe[^ЂƂi߂
		 * @exception ArgumentOutOfRangeException
		 *     (_DEBUG`̂)Ce[^I[܂ŒBĂԂł̃o֐ĂԂƁA
		 *     ̗OX[B
		 */
		typename T::value_type GetNext(void)
		{
#ifdef _DEBUG
			if (mCurrent == mEnd)
				throw ArgumentOutOfRangeException();
#endif

			return *mCurrent++;
		}

		/**
		 * @brief vfoBvfփCe[^͓ȂB
		 * @remarks
		 *     Ce[^͓Ȃ
		 */
		typename T::value_type PeekNext(void) const
		{
			return *mCurrent;
		}

		/**
		 * @brief vf̃|C^oBvfփCe[^͓ȂB
		 * @remarks
		 *     Ce[^͓Ȃ
		 */
		typename T::pointer PeekNextPtr(void) const
		{
			return &(*mCurrent);
		}

		/**
		 * @brief vfփCe[^ЂƂi߂
		 * @exception ArgumentOutOfRangeException
		 *     (_DEBUG`̂)Ce[^I[܂ŒBĂԂł̃o֐ĂԂƁA
		 *     ̗OX[B
		 */
		void MoveNext(void)
		{
#ifdef _DEBUG
			if (mCurrent == mEnd)
				throw ArgumentOutOfRangeException();
#endif

			++mCurrent;
		}
	};

	/**
	 * @brief map ReĩCe[^bv
	 *
	 * ̃NX́ANX̓ŎgpĂReiJ邱ƂȂ
	 * Ce[VƂł郉bp[B
	 * gp͎O`FbN end ̏`FbNsvB
	 */
	template <class T>
	class MapIterator
	{
	private:
		typename T::iterator mCurrent;
		typename T::iterator mEnd;

		// p[^̂ȂRXgN^͎gpłȂ
		MapIterator() {};

	public:
		typedef typename T::mapped_type MappedType;
		typedef typename T::key_type KeyType;

		/**
		 * @brief RXgN^
		 * @param start Ce[^̊Jnn_
		 * @param end   Ce[^̏In_
		 */
		MapIterator(typename T::iterator start, typename T::iterator end)
			: mCurrent(start), mEnd(end)
		{
		}

		/**
		 * @brief RXgN^
		 * @param c }bvnRei
		 */
		MapIterator(T &c)
			: mCurrent(c.begin()), mEnd(c.end())
		{
		}

		/**
		 * @brief Ce[^I[ɒBĂ邩ǂl擾
		 * @return RNVɂ܂vfꍇ͐^Ԃ
		 */
		bool HasMoreElements(void) const
		{
			return mCurrent != mEnd;
		}

		/**
		 * @brief vfiljoAvfփCe[^ЂƂi߂
		 * @exception ArgumentOutOfRangeException
		 *     (_DEBUG`̂)Ce[^I[܂ŒBĂԂł̃o֐ĂԂƁA
		 *     ̗OX[B
		 */
		typename T::mapped_type GetNext(void)
		{
#ifdef _DEBUG
			if (mCurrent == mEnd)
				throw ArgumentOutOfRangeException();
#endif

			return (mCurrent++)->second;
		}

		/**
		 * @brief vf̃L[̒loBvfփCe[^͓ȂB
		 * @remarks
		 *     Ce[^͓Ȃ
		 */
		typename T::key_type PeekNextKey(void)
		{
			return mCurrent->first;
		}

		/**
		 * @brief vfilj̒loBvfփCe[^͓ȂB
		 * @remarks
		 *     Ce[^͓Ȃ
		 */
		typename T::mapped_type PeekNextValue(void)
		{
			return mCurrent->second;
		}
	};

	/**
	 * @brief vector, list Rei const Ce[^bv
	 *
	 * ̃NX́ANX̓ŎgpĂReiJ邱ƂȂ
	 * Ce[VƂł郉bp[B
	 * gp͎O`FbN end ̏`FbNsvB
	 */
	template <class T>
	class ConstVectorIterator
	{
	private:
		mutable typename T::const_iterator mCurrent;
		typename T::const_iterator mEnd;

		// p[^̂ȂRXgN^͎gpłȂ
		ConstVectorIterator();

	public:
		typedef typename T::value_type ValueType;

		/**
		 * @brief RXgN^
		 * @param start Ce[^̊Jnn_
		 * @param end   Ce[^̏In_
		 */
		ConstVectorIterator(typename T::const_iterator start, typename T::const_iterator end)
			: mCurrent(start),
			  mEnd(end)
		{
		}

		/**
		 * @brief Ce[^I[ɒBĂ邩ǂl擾
		 * @return RNVɂ܂vfꍇ͐^Ԃ
		 */
		bool HasMoreElements(void) const
		{
			return mCurrent != mEnd;
		}

		/**
		 * @brief vfoAvfփCe[^ЂƂi߂
		 * @exception ArgumentOutOfRangeException
		 *     (_DEBUG`̂)Ce[^I[܂ŒBĂԂł̃o֐ĂԂƁA
		 *     ̗OX[B
		 */
		typename T::value_type GetNext(void)
		{
#ifdef _DEBUG
			if (mCurrent == mEnd)
				throw ArgumentOutOfRangeException();
#endif

			return *mCurrent++;
		}

		/**
		 * @brief vfoBvfփCe[^͓ȂB
		 * @remarks
		 *     Ce[^͓Ȃ
		 */
		typename T::value_type PeekNext(void) const
		{
			return *mCurrent;
		}

		/**
		 * @brief vf̃|C^oBvfփCe[^͓ȂB
		 * @remarks
		 *     Ce[^͓Ȃ
		 */
		typename T::const_pointer PeekNextPtr(void) const
		{
			return &(*mCurrent);
		}

		/**
		 * @brief vfփCe[^ЂƂi߂
		 * @exception ArgumentOutOfRangeException
		 *     (_DEBUG`̂)Ce[^I[܂ŒBĂԂł̃o֐ĂԂƁA
		 *     ̗OX[B
		 */
		void MoveNext(void) const
		{
#ifdef _DEBUG
			if (mCurrent == mEnd)
				throw ArgumentOutOfRangeException();
#endif

			++mCurrent;
		}
	};
}

#endif