#ifndef __BuddhaModelMesh_H__
#define __BuddhaModelMesh_H__

#include "BuddhaXNAPrerequisites.h"
#include "BuddhaVertexBuffer.h"
#include "BuddhaIndexBuffer.h"
#include "BuddhaEffect.h"
#include "BuddhaModelMeshMaterial.h"

#include <vector>

namespace BuddhaXNA
{
	class Model;
	struct Material;
	class Model;
	class ModelMeshPart;

	/// f̈ꕔł郁bV킷NX
	class ModelMesh
	{
		friend Model;
		DWORD mMaterialNum;

	public:
		typedef std::vector<ModelMeshMaterial*> ModelMeshMaterialList;
		typedef std::vector<ModelMeshPart*> ModelMeshPartList;

		typedef std::vector<EffectPtr> EffectList;

	protected:
		Model* m_pModel;

		ModelMeshMaterialList mMaterialList;

		ModelMeshPartList mModelMeshPartList;

		EffectList	mEffectList;

		D3DXMATERIAL mMaterial;

		ModelMesh(Model* model, DWORD materialNum);

		/// L̒_obt@
		VertexBufferPtr	mVertexBuffer;
		int mNumVertexes;

		/// L̃CfbNXobt@
		IndexBufferPtr	mIndexBuffer;

		/// FVF
		DWORD _fvf;

	public:
		virtual ~ModelMesh();

		/**
		 * @brief bVɊ֘AtꂽGtFNg̐擾
		 */
		int GetNumEffects(void) const
		{
			return static_cast<int>(mEffectList.size());
		}

		/**
		 * @brief bVɊ֘AtꂽGtFNg̋L|C^擾
		 * @param idx CfbNX
		 * @exception ArgumentOutOfRangeException w肵CfbNX{[i[z͈̔͂𒴂Ă
		 */
		EffectPtr GetEffectPtr(int idx) const;

		/**
		 * @brief bVɊ֘AtꂽGtFNg̃|C^擾
		 * @param idx CfbNX
		 * @exception ArgumentOutOfRangeException w肵CfbNX{[i[z͈̔͂𒴂Ă
		 */
		Effect* GetEffect(int idx) const;

		void Draw();

		/// ̃fbVp[g̐擾
		int GetNumMeshPart(void) const;

		/// w肵CfbNX̃fbVp[g𓾂
		ModelMeshPart* GetModelMeshPart(int idx) const;

		/// ̃fbV}eA̐擾
		int GetNumMaterials(void) const;

		/// w肵CfbNXiAgr[gIDj̃}eA擾
		const ModelMeshMaterial* GetMaterial(int idx) const;


		int GetNumVertexes(void) const;

		virtual const VertexBuffer* GetVertexBuffer(void) const
		{
			return mVertexBuffer.GetPointer();
		}

		virtual VertexBufferPtr GetVertexBufferPtr(void) const
		{
			return mVertexBuffer;
		}

		/**
		 * p[^ɃANZX邽߂ɁAbVɊ֘AtꂽCfbNXobt@ւ̃|C
		 * ^擾B
		 *
		 * @remarks
		 *     ꂽ|C^i[ꍇ́AGetIndexBufferPtr() Ŏ擾\ȋL|C^p
		 *     邱
		 */
		virtual const IndexBuffer* GetIndexBuffer(void) const
		{
			return mIndexBuffer.GetPointer();
		}

		virtual IndexBufferPtr GetIndexBufferPtr(void) const
		{
			return mIndexBuffer;
		}
	};
}

#endif