#ifndef __BuddhaTexture2D_H__
#define __BuddhaTexture2D_H__

#include <d3dx9.h>
#include "BuddhaRectangle.h"
#include "BuddhaSharedPtr.h"

namespace BuddhaXNA
{
	class GraphicsDevice;
	class RenderTarget2D;
	class Texture2DPtr;

	class Texture2D
	{
	protected:
		LPDIRECT3DTEXTURE9 m_pTexture;
		Rectangle mRectangle;
		RECT mRect;

		friend RenderTarget2D;

	public:
		Texture2D();
		Texture2D(GraphicsDevice* device, int width, int height, int numberLevels, DWORD usage, D3DFORMAT format);

		virtual ~Texture2D();

		static void FromFile(GraphicsDevice* device, LPCWSTR filePath, Texture2D** pOut);
		static Texture2DPtr FromFile(GraphicsDevice* device, LPCWSTR filePath);

		/// 11̃_~[eNX`쐬܂
		static Texture2D* CreateDummy(GraphicsDevice* device);

		LPDIRECT3DTEXTURE9 _getD3D9Texture() const
		{
			return m_pTexture;
		}

		void _setRectangle(Rectangle rect)
		{
			mRectangle = rect;

			mRect.left = mRectangle.X;
			mRect.right = mRectangle.X + mRectangle.Width;
			mRect.top = mRectangle.Y;
			mRect.bottom = mRectangle.Y + mRectangle.Height;
		}

		Rectangle GetRectangle(void) const
		{
			return mRectangle;
		}

		RECT GetRect(void) const
		{
			return mRect;
		}
	};

	class Texture2DPtr : public SharedPtr<Texture2D>
	{
	public:
		Texture2DPtr() : SharedPtr<Texture2D>() {}
		explicit Texture2DPtr(Texture2D* rep) : SharedPtr<Texture2D>(rep) {}
		Texture2DPtr(const Texture2DPtr &r) : SharedPtr<Texture2D>(r) {}
	protected:
		void destory(void)
		{
			SharedPtr<Texture2D>::destroy();
		}
	};
}


#endif