#include "BuddhaXNAPrerequisites.h"
#include "BuddhaFont.h"
#include "BuddhaGraphicsDevice.h"

namespace BuddhaXNA
{
	BuddhaFont::BuddhaFont(GraphicsDevice *device, LPCWSTR fontFace, int size)
	{
		m_pDXFont = NULL;

		mSize = size;

		HRESULT hr = D3DXCreateFont(device->_getD3D9Device(),
			mSize, // height
			0,  // adv weight
			FW_NORMAL, // bold level
			1,  // mipmap level
			false, // itaric?
			SHIFTJIS_CHARSET,  // charset umm,
			OUT_DEFAULT_PRECIS,	// output precision
			DEFAULT_QUALITY,
			DEFAULT_PITCH || FF_DONTCARE,
			fontFace,
			&m_pDXFont);
	}
	//------------------------------------------------------------------------
	BuddhaFont::~BuddhaFont()
	{
		SAFE_RELEASE(m_pDXFont);
	}
}
