#include "BuddhaGpuEffectTechnique.h"

#include "BuddhaGpuEffect.h"
#include "BuddhaGpuEffectPass.h"

namespace BuddhaXNA
{
	GpuEffectTechnique::GpuEffectTechnique(GpuEffect *parentEffect, D3DXHANDLE handle)
		: EffectTechnique(),
		  m_pEffect(parentEffect),
		  m_pHandle(handle)
	{
		// pX̐𐔂ăReiɓo^
		unsigned int numPasses = 0;
		for (; m_pEffect->m_pEffect->GetPass(m_pHandle, numPasses) != NULL ; numPasses++);

		mEffectPassList.resize(numPasses);

		for (unsigned int i = 0; i < numPasses; i++)
		{
			mEffectPassList[i] = new GpuEffectPass(m_pEffect, i);
		}
	}
	//------------------------------------------------------------------------
	GpuEffectTechnique::~GpuEffectTechnique()
	{
	}
	//------------------------------------------------------------------------
	int GpuEffectTechnique::GetNumPasses(void)
	{
		return static_cast<int>(mEffectPassList.size());
	}
	//------------------------------------------------------------------------
	EffectPass* GpuEffectTechnique::GetPass(unsigned int idx)
	{
		if (idx < mEffectPassList.size())
		{
			return mEffectPassList[idx];
		}

		// TODO
		throw "Missing idex";
	}
}
