#include "BuddhaHardwareEffect.h"

#include "BuddhaGraphicsDevice.h"
#include "BuddhaMatrix.h"
#include "BuddhaHardwareEffectPass.h"

namespace BuddhaXNA
{
	HardwareEffect::HardwareEffect(GraphicsDevice *device)
		: Effect(),
		  m_pDevice(device),
		  mLightingEnabled(false)
	{
		HardwareEffectTechnique* teq = new HardwareEffectTechnique(this);

		mTechniqueList.resize(1);
		mTechniqueList[0] = teq;

		m_pCurrentTechnique = teq;
	}
	//------------------------------------------------------------------------
	HardwareEffect::~HardwareEffect()
	{
	}
	//------------------------------------------------------------------------
	void HardwareEffect::Begin(void)
	{
		// vO}uVF[_Jbg
		m_pDevice->_setSoftwareVertexProcessing(false);
	}
	//------------------------------------------------------------------------
	HardwareEffectTechnique::HardwareEffectTechnique(HardwareEffect* effect)
		: EffectTechnique()
	{
		HardwareEffectPass* pass = new HardwareEffectPass(effect);

		mEffectPassList.resize(1);
		mEffectPassList[0] = pass;
	}
}