#include "BuddhaXNAPrerequisites.h"
#include "BuddhaIndexBuffer.h"
#include "BuddhaGraphicsDevice.h"

using namespace BuddhaXNA;

const D3DFORMAT IndexElementSize::SixteenBits = D3DFMT_INDEX16;
const D3DFORMAT IndexElementSize::ThirtyTwoBits = D3DFMT_INDEX32;

IndexBuffer::IndexBuffer(GraphicsDevice* device, int sizeInBytes, DWORD usage, D3DPOOL resourceManagementMode, D3DFORMAT elementSize)
{
	m_pIndexBuffer = NULL;
	device->_getD3D9Device()->CreateIndexBuffer(sizeInBytes, usage, elementSize, resourceManagementMode, &m_pIndexBuffer, NULL);
}

IndexBuffer::~IndexBuffer()
{
	SAFE_RELEASE(m_pIndexBuffer);
}

void IndexBuffer::SetData(short *src, int length)
{
	UINT size = sizeof(SHORT) * length;
	VOID* pIndices;
	m_pIndexBuffer->Lock(0, size, (VOID**)&pIndices, 0);

	memcpy(pIndices, src, size);

	m_pIndexBuffer->Unlock();
}
