#include "BuddhaPlane.h"

namespace BuddhaXNA
{
	Plane::Plane(void)
		: Normal(Vector3::Zero), D(0.0f)
	{
	}
	//------------------------------------------------------------------------
	Plane::Plane(Vector3 normal, FLOAT d)
		: Normal(normal), D(d)
	{
	}
	//------------------------------------------------------------------------
	Plane::Side Plane::GetSide(const Vector3 &position) const
	{
		FLOAT distance = GetDistance(position);

		if (distance < 0.0f)
			return PlaneSide::Negative;

		if (distance > 0.0f)
			return PlaneSide::Positive;

		return PlaneSide::No;
	}
	//------------------------------------------------------------------------
	FLOAT Plane::GetDistance(const Vector3 &position) const
	{
		return Vector3::Dot(Normal, position) + D;
	}
}