#include "BuddhaRenderTarget2D.h"

#include "BuddhaGraphicsDevice.h"
#include "BuddhaRectangle.h"
#include "BuddhaTexture2D.h"

namespace BuddhaXNA
{
	RenderTarget2D::RenderTarget2D(GraphicsDevice* device, int width, int height, int numberLevels, D3DFORMAT format)
		: mWidth(width), mHeight(height)
	{
		HRESULT hr;

		// eNX`쐬
		hr = D3DXCreateTexture(
			device->_getD3D9Device(),
			width, height, numberLevels,
			D3DUSAGE_RENDERTARGET,	// ꂵwłȂ
			format,
			D3DPOOL_DEFAULT,
			&m_pTexture
		);

		if (FAILED(hr))
			throw "Could not create texture.";

		// T[tFCX
		m_pTexture->GetSurfaceLevel(0, &m_pSurface);
	}
	//------------------------------------------------------------------------
	RenderTarget2D::~RenderTarget2D(void)
	{
		SAFE_RELEASE(m_pTexture);
		SAFE_RELEASE(m_pSurface);
	}
	//------------------------------------------------------------------------
	LPDIRECT3DSURFACE9 RenderTarget2D::_getD3D9Surface(void)
	{
		return m_pSurface;
	}
	//------------------------------------------------------------------------
	Texture2D* RenderTarget2D::GetTexture(void)
	{
		// eNX`쐬..
		Texture2D* tex = new Texture2D();
		tex->m_pTexture = m_pTexture;
		tex->m_pTexture->AddRef();

		Rectangle rect;

		rect.X = 0;
		rect.Y = 0;
		rect.Width = mWidth;
		rect.Height = mHeight;

		tex->_setRectangle(rect);

		return tex;
	}
}