#include <d3dx9.h>
#include "BuddhaSpriteBatch.h"
#include "BuddhaGraphicsDevice.h"
#include "BuddhaTexture2D.h"
#include "BuddhaVector2.h"

namespace BuddhaXNA
{
	SpriteBatch::SpriteBatch(GraphicsDevice *device)
	{
		m_pDevice = device;
		m_pSprite = NULL;

		HRESULT hr = D3DXCreateSprite(m_pDevice->_getD3D9Device(), &m_pSprite);
		// TODO ɗOǉ
	}
	//------------------------------------------------------------------------
	SpriteBatch::~SpriteBatch()
	{
		SAFE_RELEASE(m_pSprite);
	}
	//------------------------------------------------------------------------
	void SpriteBatch::Begin(void)
	{
		m_pSprite->Begin(D3DXSPRITE_DONOTSAVESTATE);
	}
	//------------------------------------------------------------------------
	void SpriteBatch::Begin(Buddha_SpriteBlendMode blendMode)
	{
		switch (blendMode)
		{
		case ADDITIVE:
			m_pSprite->Begin(D3DXSPRITE_DONOTSAVESTATE);
			break;
		case ALPHABLEND:
			m_pSprite->Begin(D3DXSPRITE_ALPHABLEND | D3DXSPRITE_DONOTSAVESTATE);
			break;
		case NONE:
			m_pSprite->Begin(D3DXSPRITE_DONOTSAVESTATE);
			break;
		}
	}
	//------------------------------------------------------------------------
	void SpriteBatch::Draw(const Texture2DPtr &texture, const Rectangle &rect, const Color &color)
	{
		// RECT srcRect = {rect.X, rect.Y, rect.Width, rect.Height};
		// Draw(tex, srcRect, color);
	}
	//------------------------------------------------------------------------
	void SpriteBatch::Draw(const Texture2DPtr &texture, const RECT &srcRect, const Color &color)
	{
		// m_pSprite->Draw(tex->_getD3D9Texture(), &srcRect, NULL, NULL, color);
	}
	//------------------------------------------------------------------------
	void SpriteBatch::Draw(const Texture2DPtr &texture, const Vector2 &vector, const Color &color)
	{
		D3DXVECTOR3 t_position(vector.X, vector.Y, 0);
		m_pSprite->Draw(texture->_getD3D9Texture(), NULL, NULL, &t_position, color._getPackedColor());
	}
	//------------------------------------------------------------------------
	void SpriteBatch::End(void)
	{
		m_pSprite->End();
	}
	//------------------------------------------------------------------------
	void SpriteBatch::DrawString(const BuddhaFontPtr &font, LPCWSTR text, const Vector2 &position, const Color &color)
	{
		RECT rect = {
			(int)position.X,
			(int)position.Y,
			lstrlenW(text) * font->mSize / 2,
			(int)(position.Y + font->mSize)
		};

		HRESULT hr;
		
		hr = font->m_pDXFont->DrawText(
			m_pSprite,
			text,
			-1,
			&rect,
			DT_LEFT | DT_NOCLIP,
			D3DCOLOR_ARGB(color.A, color.R, color.G, color.B)
		);
	}
}