#include "BuddhaStringConvert.h"

#include <iostream>
#include <sstream>

namespace BuddhaXNA
{
	int StringConvert::ParseInt(const String &val)
	{
		std::wistringstream str(val);
		int ret;
		str >> ret;

		return ret;
	}
	//------------------------------------------------------------------------
	void StringConvert::ToLPSTR(const String &from, LPSTR out, size_t size)
	{
		int length = WideCharToMultiByte(CP_ACP, 0, from.c_str(), -1, NULL, 0, NULL, NULL);

		if ((size_t)length >= size - 1) {
			return;
		}

		ZeroMemory(out, size);
		WideCharToMultiByte(CP_ACP, 0, from.c_str(), -1, out, length, NULL, NULL);
	}
	//------------------------------------------------------------------------
	AsciiString StringConvert::ToAsciiString(const String &from)
	{
		int length = WideCharToMultiByte(CP_ACP, 0, from.c_str(), -1, NULL, 0, NULL, NULL);
		LPSTR t_str = (LPSTR)malloc(length + 1);
		ZeroMemory(t_str, length + 1);
		WideCharToMultiByte(CP_ACP, 0, from.c_str(), -1, t_str, length, NULL, NULL);

		AsciiString str = t_str;

		free(t_str);

		return str;
	}
	//------------------------------------------------------------------------
	String AsciiStringConvert::ToString(const AsciiString &from)
	{
		int length = MultiByteToWideChar(CP_ACP, 0, from.c_str(), -1, NULL, 0);

		size_t size = sizeof(WCHAR) * (length + 1);
		LPWSTR t_str = (LPWSTR)malloc(size);
		ZeroMemory(t_str, size);

		MultiByteToWideChar(CP_ACP, 0, from.c_str(), -1, t_str, length);

		String ret(t_str);

		free(t_str);

		return ret;
	}
	//------------------------------------------------------------------------
	String AsciiStringConvert::ToString(const char* from)
	{
		return ToString(AsciiString(from));
	}
}